<template>
  
	<v-card>

		<v-toolbar
		dark
		color="brown"
		>

		<v-btn
		icon
		dark
		v-on:click.native="close"
		>
			<v-icon>mdi-close</v-icon>
		</v-btn>
			<v-toolbar-title class="title white--text pl-0">
				Selamat Datang di Crowd Funding Sahabat Kita!
			</v-toolbar-title>
		</v-toolbar>

			<v-img
				height="200px"
				src="https://images.unsplash.com/photo-1520961536084-445e75e10ee0?ixlib=rb-1.2.1&ixid=eyJhcHBfaWQiOjEyMDd9&auto=format&fit=crop&w=750&q=80">
				<v-app-bar flat color="rgba(0, 0, 0, 0)">
					
				<v-spacer></v-spacer>

				</v-app-bar>
			</v-img> 

        <v-card-title>
			Login Form
		</v-card-title>

        <v-card-text>

			<v-form
				ref="form"
				v-model="valid"
				lazy-validation>

				<v-text-field
					v-model="email"
					:rules="emailRules"
					label="E-mail"
					required
					append-icon="mdi-email">
				</v-text-field>

				<v-text-field
					v-model="password"
					:rules="passwordRules"
					:append-icon="show1 ? 'mdi-eye' : 'mdi-eye-off'"
            		:type="show1 ? 'text' : 'password'"
					@click:append="show1 = !show1"
					label="Password"
					counter
					hint="at least 6 characters"
					required>
				</v-text-field>

				<v-btn
					:disabled="!valid"
					color="success"
					class="mr-4"
					@click="validate">
					Login
					<v-icon right dark>mdi-lock-open</v-icon>
				</v-btn>

				<v-btn					
					color="primary"
					class="mr-4"
					@click="loginToGoogle('google')">
					Login
					<v-icon right dark>mdi-google</v-icon>
				</v-btn>

				<v-btn
					color="error"
					class="mr-4"
					@click="reset">
					Reset
				</v-btn>

				<alert/>

			</v-form>

        </v-card-text>
        
    </v-card>

</template>

<script>
import alert from '../../components/Alert.vue'
import {mapActions} from 'vuex'

export default {
	
	components:{
		alert
	},

	data:function(){
		return{
			valid: true,
			password: '',
			show1: false,
			passwordRules: [
				v => !!v || 'Password is required',
				v => (v && v.length > 0) || 'Password Must Be Valid!',
			],
			email: '',
			emailRules: [
				v => !!v || 'E-mail is required',
				v => /.+@.+\..+/.test(v) || 'E-mail must be valid',
			],		
		}
	},methods:{
		async submit(){
			try {
				 let response = await axios.post('/api/auth/login', this.login())
				
				 if(response.status == 200){					
					 
					let {response_message, response_code, data} = response.data 	

					this.message = response_message

					if(response_code=="00"){

						this.show({
							title:'success',
							message:response_message,
						})
						
						this.$refs.form.reset()						
						this.loginStorageModule(data)						
						this.close()
					}else{
						
						this.show({
							title:'error',
							message:response_message,
						})

					}

				 }else{

					let {response_message, response_code, data} = response.data
					this.show({
						title:'error',
						message:response_message,
					})

				 }
			} catch (e) {

				console.log(e);

				let {response_message, message, errors} = e.response.data
				
				console.log('Error is comming');
				console.log(errors);

				this.show({
					title:'error',
					message:message || response_message,
					theErrors:errors
				})
			}
		},
		validate:function () {
			let isSuccessfullyValidated = this.$refs.form.validate()
			if(isSuccessfullyValidated){
				console.log(`the input parameter is: ${this.email}`)
				this.submit()
			}else{
				console.log(`the problematic input parameter is: ${this.email}`)
				
				this.show({
					title:'error',
					message:'Your input is not valid!',
					theErrors:[]
				})
			}
			
		},
		reset:function () {
			this.$refs.form.reset()
			this.$refs.form.resetValidation()
		},
		login:function(){
			return{
				password:this.password,
				email:this.email
			}
		},
		...mapActions({
			loginStorageModule:'authenticate/login',
			show:'alert/show'
		}),
		close:function(){
			this.$emit('closed',false)
		},
		async loginToGoogle(provider) {
			try {
				
				let response = await axios.get(`/api/auth/login/social/${provider}`)

				if(response.status==200){

					let {url} = response.data
					window.location.href=url

				}else{
					
					this.alert({
						title:'error',
						message:'Login via google gagal'
					})

				}

			} catch (error) {
				
				console.log(error)
				this.alert({
						title:'error',
						message:'Login via google gagal'
					})

			}
			
			
		},
					

	},mounted: function(){
		console.log('Login Screen Mounted')
	}
}
</script>

<style>

</style>